import { Directive, ViewContainerRef, TemplateRef, Input, ɵstringify, NgModule } from '@angular/core';
import { filter } from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
/**
 * \@publicApi
 * @template T
 */
var  /**
 * \@publicApi
 * @template T
 */
NgxUnlessContext = /** @class */ (function () {
    function NgxUnlessContext() {
        this.$implicit = /** @type {?} */ ((null));
        this.ngxUnless = /** @type {?} */ ((null));
    }
    return NgxUnlessContext;
}());
if (false) {
    /** @type {?} */
    NgxUnlessContext.prototype.$implicit;
    /** @type {?} */
    NgxUnlessContext.prototype.ngxUnless;
}
/**
 * @template T
 */
var NgUnlessDirective = /** @class */ (function () {
    function NgUnlessDirective(_viewContainer, templateRef) {
        this._viewContainer = _viewContainer;
        this._context = new NgxUnlessContext();
        this._thenTemplateRef = null;
        this._elseTemplateRef = null;
        this._thenViewRef = null;
        this._elseViewRef = null;
        this._thenTemplateRef = templateRef;
    }
    Object.defineProperty(NgUnlessDirective.prototype, "ngxUnless", {
        /**
         * The Boolean expression to evaluate as the condition for showing a template.
         */
        set: /**
         * The Boolean expression to evaluate as the condition for showing a template.
         * @param {?} condition
         * @return {?}
         */
        function (condition) {
            this._context.$implicit = this._context.ngxUnless = condition;
            this._updateView();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgUnlessDirective.prototype, "ngxUnlessThen", {
        /**
         * A template to show if the condition expression evaluates to true.
         */
        set: /**
         * A template to show if the condition expression evaluates to true.
         * @param {?} templateRef
         * @return {?}
         */
        function (templateRef) {
            assertTemplate('ngxUnlessThen', templateRef);
            this._thenTemplateRef = templateRef;
            this._thenViewRef = null; // clear previous view if any.
            this._updateView();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgUnlessDirective.prototype, "ngxUnlessElse", {
        /**
         * A template to show if the condition expression evaluates to false.
         */
        set: /**
         * A template to show if the condition expression evaluates to false.
         * @param {?} templateRef
         * @return {?}
         */
        function (templateRef) {
            assertTemplate('ngxUnlessElse', templateRef);
            this._elseTemplateRef = templateRef;
            this._elseViewRef = null; // clear previous view if any.
            this._updateView();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NgUnlessDirective.prototype._updateView = /**
     * @return {?}
     */
    function () {
        if (this._context.$implicit) {
            if (!this._elseViewRef) {
                this._viewContainer.clear();
                this._thenViewRef = null;
                if (this._elseTemplateRef) {
                    this._elseViewRef = this._viewContainer.createEmbeddedView(this._elseTemplateRef, this._context);
                }
            }
        }
        else {
            if (!this._thenViewRef) {
                this._viewContainer.clear();
                this._elseViewRef = null;
                if (this._thenTemplateRef) {
                    this._thenViewRef = this._viewContainer.createEmbeddedView(this._thenTemplateRef, this._context);
                }
            }
        }
    };
    NgUnlessDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngxUnless]',
                },] }
    ];
    /** @nocollapse */
    NgUnlessDirective.ctorParameters = function () { return [
        { type: ViewContainerRef },
        { type: TemplateRef }
    ]; };
    NgUnlessDirective.propDecorators = {
        ngxUnless: [{ type: Input }],
        ngxUnlessThen: [{ type: Input }],
        ngxUnlessElse: [{ type: Input }]
    };
    return NgUnlessDirective;
}());
if (false) {
    /** @type {?} */
    NgUnlessDirective.prototype._context;
    /** @type {?} */
    NgUnlessDirective.prototype._thenTemplateRef;
    /** @type {?} */
    NgUnlessDirective.prototype._elseTemplateRef;
    /** @type {?} */
    NgUnlessDirective.prototype._thenViewRef;
    /** @type {?} */
    NgUnlessDirective.prototype._elseViewRef;
    /** @type {?} */
    NgUnlessDirective.prototype._viewContainer;
}
/**
 * @param {?} property
 * @param {?} templateRef
 * @return {?}
 */
function assertTemplate(property, templateRef) {
    /** @type {?} */
    var isTemplateRefOrNull = !!(!templateRef || templateRef.createEmbeddedView);
    if (!isTemplateRefOrNull) {
        throw new Error(property + " must be a TemplateRef, but received '" + ɵstringify(templateRef) + "'.");
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var NgxUnlessModule = /** @class */ (function () {
    function NgxUnlessModule() {
    }
    NgxUnlessModule.decorators = [
        { type: NgModule, args: [{
                    imports: [],
                    declarations: [NgUnlessDirective],
                    exports: [NgUnlessDirective],
                },] }
    ];
    return NgxUnlessModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
/**
 * @param {?} predicate
 * @return {?}
 */
function ngxUnless(predicate) {
    return function (source) {
        return source.pipe(filter(function (args) { return !predicate(args); }));
    };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */

var _rxjs = /*#__PURE__*/Object.freeze({
    __proto__: null,
    ngxUnless: ngxUnless
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
/** @type {?} */
var rxjs = _rxjs;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */

export { NgUnlessDirective, NgxUnlessContext, NgxUnlessModule, rxjs };
//# sourceMappingURL=ngx-unless.js.map
