import { ViewContainerRef, TemplateRef } from '@angular/core';
/**
 * @publicApi
 */
export declare class NgxUnlessContext<T = any> {
    $implicit: T;
    ngxUnless: T;
}
export declare class NgUnlessDirective<T = any> {
    private _viewContainer;
    private _context;
    private _thenTemplateRef;
    private _elseTemplateRef;
    private _thenViewRef;
    private _elseViewRef;
    constructor(_viewContainer: ViewContainerRef, templateRef: TemplateRef<NgxUnlessContext<T>>);
    /**
     * The Boolean expression to evaluate as the condition for showing a template.
     */
    ngxUnless: T;
    /**
     * A template to show if the condition expression evaluates to true.
     */
    ngxUnlessThen: TemplateRef<NgxUnlessContext<T>> | null;
    /**
     * A template to show if the condition expression evaluates to false.
     */
    ngxUnlessElse: TemplateRef<NgxUnlessContext<T>> | null;
    private _updateView;
}
